//
//  CoordinateTransforms.cpp
//  Program4
//
//  Created by Lucas David on 2/23/14.
//  Copyright (c) 2014 lucashd. All rights reserved.
//

#include "CoordinateTransforms.h"


float p2wx(int in_x, int g_width, int g_height) {
    //fill in with the correct return value
    float c, d;
    float l, r;
    float wx;
    
    if (g_width > g_height) {
        l = -g_width/g_height;
        r = g_width/g_height;
    }
    else {
        l = -1;
        r = 1;
    }
    
    c = (-g_width + 1.0)/(l - r);
    d = ((-g_width + 1.0)/(l - r)) * -l;
    
    wx = (in_x - d)/c;
    return wx;
}

float p2wy(int in_y, int g_width, int g_height) {
    //flip glut y
    float e, f;
    float b, t;
    float wy;
    in_y = g_height - in_y;
    
    if (g_width > g_height) {
        b = -1;
        t = 1;
    }
    else {
        b = -g_height/g_width;
        t = g_height/g_width;
    }
    
    e = (-g_height + 1.0)/(b - t);
    f = ((-g_height + 1.0)/(b - t)) * -b;
    
    wy = (in_y - f)/e;
    
    //fill in with the correct return value
    return wy;
}
